unit untBoardCategory;

interface

uses
  Graphics, Classes, Contnrs,
  untOnlineBoard;

type
  TBoardCategory = class
  protected
    FBoardList: TObject;
    FBoardCache: TObjectList;
  public
    Opened: boolean;
    CategoryName: string;
    Color: TColor;
    Boards: TList;
    constructor Create(bl: TObject);
    destructor  Destroy; override;
    function AddBoard(const Server, BoardName, DisplayName: string): TOnlineBoard;
    function GetBoard(const Server, BoardName: string): TOnlineBoard;
  end;

implementation

uses
  untBoard, untGlobal, untBoard2ch, untBoardJBBS;

function TBoardCategory.GetBoard(const Server, BoardName: string): TOnlineBoard;
var
  i: integer;
  b: TOnlineBoard;
begin
  result := nil;

  for i := 0 to FBoardCache.Count - 1 do
  begin
    b := TOnlineBoard(FBoardCache[i]);
    if (b.BoardName = BoardName) then
      if (b.Server = Server) or ('c.2ch.net' = Server) then
      begin
        result := b;
        break;
      end;

  end;
end;

function TBoardCategory.AddBoard(const Server, BoardName, DisplayName: string): TOnlineBoard;
var
  newBoard: TOnlineBoard;
  bbs: TBBSType;

begin
  bbs := GetBBSType(Server);

  //20140308 2chWƂĔĂ
  newBoard := TBoard2ch.Create;

  //JBBSOIɏ
  if (bbs = btJBBS) then
  begin
    newBoard.Free;
    newBoard := TBoardJBBS.Create;
  end;

  newBoard.Server      := Server;
  newBoard.BoardName   := BoardName;
  newBoard.DisplayName := DisplayName;
  newBoard.BoardList   := FBoardList;
  newBoard.Category    := self;
  newBoard.SubjectURL  := 'http://' + Server + '/' + BoardName + '/subject.txt';
  FBoardCache.Add(newBoard);
  Boards.Add(newBoard);

  result := newBoard;
end;

constructor TBoardCategory.Create(bl: TObject);
begin
  inherited Create;

  FBoardList := bl;
  FBoardCache := TObjectList.Create;
  Boards := TList.Create;
end;

destructor TBoardCategory.Destroy;
begin
  Boards.Free;
  FBoardCache.Clear;
  FBoardCache.Free;

  inherited;
end;

end.
